OpenBitSetIterator (Lucene 3.6.2 API)
Keywords: org.apache.lucene.util.OpenBitSetIterator class

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.apache.lucene.util
Class OpenBitSetIterator

    java.lang.Object
      org.apache.lucene.search.DocIdSetIterator
          org.apache.lucene.util.OpenBitSetIterator

    public class OpenBitSetIterator

extends DocIdSetIterator

An iterator to iterate over set bits in an OpenBitSet. This is faster than nextSetBit() for iterating over the complete set of bits, especially when the density of the bits set is high.

Field Summary
`protected static int[]` | `bitlist`

Fields inherited from class org.apache.lucene.search.DocIdSetIterator
`NO_MORE_DOCS`

Constructor Summary
`OpenBitSetIterator(long[] bits, int numWords)`
`OpenBitSetIterator(OpenBitSet obs)`

Method Summary
`int` | `advance(int target)` Advances to the first beyond (see NOTE below) the current whose document number is greater than or equal to target.
`int` | `docID()` Returns the following: -1 or `DocIdSetIterator.NO_MORE_DOCS` if `DocIdSetIterator.nextDoc()` or `DocIdSetIterator.advance(int)` were not called yet.
`int` | `nextDoc()` alternate shift implementations // 32 bit shifts, but a long shift needed at the end private void shift2() { int y = (int)word; if (y==0) {wordShift +=32; y = (int)(word >>>32); } if ((y & 0x0000FFFF) == 0) { wordShift +=16; y>>>=16; } if ((y & 0x000000FF) == 0) { wordShift +=8; y>>>=8; } indexArray = bitlist[y & 0xff]; word >>>= (wordShift +1); } private void shift3() { int lower = (int)word; int lowByte = lower & 0xff; if (lowByte != 0) { indexArray=bitlist[lowByte]; return; } shift(); }

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Field Detail

### bitlist

    protected static final int[] bitlist

Constructor Detail

### OpenBitSetIterator

    public OpenBitSetIterator(OpenBitSet obs)

### OpenBitSetIterator

    public OpenBitSetIterator(long[] bits,
                              int numWords)

Method Detail

### nextDoc

    public int nextDoc()

  alternate shift implementations // 32 bit shifts, but a long shift needed at the end private void shift2() { int y = (int)word; if (y==0) {wordShift +=32; y = (int)(word >>>32); } if ((y & 0x0000FFFF) == 0) { wordShift +=16; y>>>=16; } if ((y & 0x000000FF) == 0) { wordShift +=8; y>>>=8; } indexArray = bitlist[y & 0xff]; word >>>= (wordShift +1); } private void shift3() { int lower = (int)word; int lowByte = lower & 0xff; if (lowByte != 0) { indexArray=bitlist[lowByte]; return; } shift(); }

  Specified by:
    `nextDoc` in class `DocIdSetIterator`

### advance

    public int advance(int target)

  Description copied from class: `DocIdSetIterator`
  Advances to the first beyond (see NOTE below) the current whose document number is greater than or equal to target. Returns the current document number or `DocIdSetIterator.NO_MORE_DOCS` if there are no more docs in the set.

  Behaves as if written:

       int advance(int target) {
         int doc;
         while ((doc = nextDoc()) < target) {
         }
         return doc;
       }

  Some implementations are considerably more efficient than that.

  NOTE: when `target ≤ current` implementations may opt not to advance beyond their current `DocIdSetIterator.docID()`.

  NOTE: this method may be called with `DocIdSetIterator.NO_MORE_DOCS` for efficiency by some Scorers. If your implementation cannot efficiently determine that it should exhaust, it is recommended that you check for that value in each call to this method.

  NOTE: after the iterator has exhausted you should not call this method, as it may result in unpredicted behavior.

  Specified by:
    `advance` in class `DocIdSetIterator`

### docID

    public int docID()

  Description copied from class: `DocIdSetIterator`
  Returns the following:
  - -1 or `DocIdSetIterator.NO_MORE_DOCS` if `DocIdSetIterator.nextDoc()` or `DocIdSetIterator.advance(int)` were not called yet.
  - `DocIdSetIterator.NO_MORE_DOCS` if the iterator has exhausted.
  - Otherwise it should return the doc ID it is currently on.

  Specified by:
    `docID` in class `DocIdSetIterator`

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD